import { BaseDriver, DriverInterface, StreamOptions, QueryOptions, StreamTableData, GenericDataBaseType } from '@cubejs-backend/base-driver';
import { Connection, Database } from 'duckdb';
import { DuckDBQuery } from './DuckDBQuery';
export type DuckDBDriverConfiguration = {
    dataSource?: string;
    initSql?: string;
    schema?: string;
};
type InitPromise = {
    defaultConnection: Connection;
    db: Database;
};
export declare class DuckDBDriver extends BaseDriver implements DriverInterface {
    protected readonly config: DuckDBDriverConfiguration;
    protected initPromise: Promise<InitPromise> | null;
    private schema;
    constructor(config?: DuckDBDriverConfiguration);
    toGenericType(columnType: string): GenericDataBaseType;
    protected init(): Promise<InitPromise>;
    informationSchemaQuery(): string;
    getSchemasQuery(): string;
    protected getInitiatedState(): Promise<InitPromise>;
    static dialectClass(): typeof DuckDBQuery;
    query<R = unknown>(query: string, values?: unknown[], _options?: QueryOptions): Promise<R[]>;
    stream(query: string, values: unknown[], { highWaterMark }: StreamOptions): Promise<StreamTableData>;
    testConnection(): Promise<void>;
    readOnly(): boolean;
    release(): Promise<void>;
}
export {};
//# sourceMappingURL=DuckDBDriver.d.ts.map